class Skirnir::Chef
  def initialize(defs)
    @defs = defs
  end

  def set(role, *path, value)
    #where = path.join('/')
    #puts "Set for role #{role}: #{where} = #{value}"

    h = Hash.construct(path, value)
    @defs[role] = {} unless @defs.has_key?(role)

    @defs[role].deep_merge!(h)
  end

  # @param roles [Array]
  def get_for_roles(*roles)
    roles.flatten!

    roles.unshift('all') unless roles.include?('all')

    result = {}

    roles.each do |role|
      result.deep_merge!(@defs[role]) if @defs.has_key?(role)
    end

    result
  end
end

