class Skirnir::Node
  attr_accessor :name, :roles, :chef, :run_list, :ip_int, :ip_ext

  def initialize(site_name, config)
    @name = config['name']
    @roles = config['roles']
    @run_list = @roles.map{|role| "recipe[#{site_name}::#{role}_box]"}
    @ip_int = config['ip_int']
    @ip_ext = config['ip_ext'] || @ip_int

    chef_config = config['chef'] || {}

    @chef = Skirnir::Chef.new({'all' => chef_config})

    to_h.each_pair do |key, value|
      @chef.set('all', 'box', key, value)
    end

  end

  def has_role?(role)
    @roles.include? role
  end

  # @return [Hash]
  def to_h
    {
      'name' => @name,
      'roles' => @roles,
      'ip_int' => @ip_int,
      'ip_ext' => @ip_ext
    }
  end

  # returns the chef definitions specific for this node
  def chef_hash
    @chef.get_for_roles('all')
  end

end


